#include <minigui.ch>

FUNCTION main()

SET NAVIGATION EXTENDED 

PUBLIC  cDescEfeito 

   DEFINE WINDOW barcode AT 140 , 235 ;
                         WIDTH 550;
                         HEIGHT 350;
                         TITLE "";
                         ICON NIL;
                         MAIN 

      DEFINE LABEL Label_1
         ROW 60
         COL 30
         WIDTH 120
         HEIGHT 24
         VALUE "Code"
         FONTNAME "Arial"
         FONTSIZE 9
         TOOLTIP ""
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE .T.
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .F.
         BACKCOLOR Nil
         FONTCOLOR Nil
      END LABEL

      DEFINE TEXTBOX Text_1
         ROW 60
         COL 170
         WIDTH 120
         HEIGHT 24
         FONTNAME "Arial"
         FONTSIZE 9
         TOOLTIP ""
         ONCHANGE Nil
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         ONENTER Nil
         HELPID Nil
         TABSTOP .T.
         VISIBLE .T.
         READONLY .F.
         RIGHTALIGN .F.
         BACKCOLOR Nil
         FONTCOLOR Nil
         INPUTMASK Nil
         FORMAT Nil
         VALUE ""
      END TEXTBOX

      DEFINE LABEL Label_2
         ROW 130
         COL 30
         WIDTH 250
         HEIGHT 80
         VALUE ""
         FONTNAME "Arial"
         FONTSIZE 9
         TOOLTIP ""
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE .T.
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .F.
         BACKCOLOR Nil
         FONTCOLOR Nil
      END LABEL

*-----------------Aadido------------------------*
    DEFINE LABEL Label_3
         ROW 210
         COL 030
         WIDTH 250
         HEIGHT 80
         VALUE cDescEfeito	    
         FONTNAME "Arial"
         FONTSIZE 13
         TOOLTIP ""
         FONTBOLD .T.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE .T.
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .F.
         BACKCOLOR Nil
         FONTCOLOR Nil
      END LABEL
*-----------------Aadido------------------------*

      DEFINE BUTTON Button_1
         ROW 60
         COL 320
         WIDTH 100
         HEIGHT 28
         CAPTION "Draw Code"
         ACTION play_barcode()
         FONTNAME "Arial"
         FONTSIZE 9
         TOOLTIP ""
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         HELPID Nil
         FLAT .F.
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
         PICTURE Nil
      END BUTTON

      DEFINE BUTTON BImprime
         ROW 120
         COL 320
         WIDTH 100
         HEIGHT 28
         CAPTION "Imprimir"
         ACTION ImpBarras()
         FONTNAME "Arial"
         FONTSIZE 9
         TOOLTIP ""
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         HELPID Nil
         FLAT .F.
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
         PICTURE Nil
      END BUTTON

   END WINDOW

   CENTER WINDOW barcode
   ACTIVATE WINDOW barcode

      RETURN


FUNCTION Play_Barcode()

   AddFont( "PF_I2OF5.TTF" )
   
   setproperty( "barcode" ,"label_2" ,"value",  _StrToI2of5( Barcode.Text_1.value ) )
   setproperty( "barcode" ,"label_2" ,"fontname" ,"PF Interleaved 2 of 5")
   setproperty( "barcode" ,"label_2" ,"fontsize" ,70)
   domethod("barcode" ,"label_2" ,"refresh" )
   
   RemoveFont("PF_I2OF5.TTF")

*-----------------Aadido --------------------------------*
*----------------Visor del Nmero de Barras --------------*  
   
   barcode.Label_3.Refresh  
   cDescEfeito := ALLTRIM(barcode.Text_1.value)     
   barcode.Label_3.value  := cDescEfeito

*-----------------Aadido --------------------------------*
   
   RETURN

FUNCTION AddFont(font)
   #define FR_PRIVATE 0x10
   #define FR_NOT_ENUM 0x20
   local nRet := AddFontResourceEx( font,FR_PRIVATE+ FR_NOT_ENUM, 0)
   RETURN Nil
   
FUNCTION RemoveFont(font)
   #define FR_PRIVATE 0x10
   #define FR_NOT_ENUM 0x20
   local nRet := RemoveFontResourceEx( font,FR_PRIVATE+ FR_NOT_ENUM, 0)
   RETURN Nil
   
FUNCTION _StrToI2of5(cString)

   local cStart, cStop, cRet, cCheck, cCar, nLong, nI, nSum, nAux

   cStart := chr(40)
   cStop  := chr(41)
   cRet   := alltrim(cString)

   *--- Genero dgito de control
   nLong  := len(cRet)
   nSum   := 0
   nCount := 1
   for nI := nLong to 1 step -1
      nSum   := nSum + val(substr(cRet,nI,1)) * iif(mod(nCount,2) = 0,1,3)
      nCount := nCount + 1
   next
   nAux  := mod(nSum,10)
   cRet  := cRet + alltrim(str(iif(nAux = 0,0,10 - nAux)))
   nLong := len(cRet)

   *--- La longitud debe ser par
   if mod(nLong,2) # 0
      cRet  := '0' + cRet
      nLong := len(cRet)
   endif

   *--- Convierto los pares a caracteres
   cCar = ''
   for nI := 1 to nLong step 2
      if val(subs(cRet,nI,2)) < 50
         cCar := cCar + chr(val(subs(cRet,nI,2)) + 48)
      else
         cCar := cCar + chr(val(subs(cRet,nI,2)) + 142)
      endif
   next

  *--- Armo cdigo
  cRet := cStart + cCar + cStop
  
  RETURN( cRet )
  
DECLARE DLL_TYPE_INT AddFontResourceEx ( DLL_TYPE_LPCTSTR lpszFilename, DLL_TYPE_DWORD fl, DLL_TYPE_LPVOID pdv ) IN GDI32.DLL
DECLARE DLL_TYPE_BOOL RemoveFontResourceEx ( DLL_TYPE_LPCTSTR lpFileName, DLL_TYPE_DWORD fl, DLL_TYPE_LPVOID pdv ) IN GDI32.DLL

***************************************
Procedure ImpBarras()
Local  lSuccess,nCant,DibBarras         

If Empty (BarCode.Text_1.value)
   Msginfo("Ingrese los datos...")
   return
endif

SELECT PRINTER DIALOG TO lSuccess

AddFont( "PF_I2OF5.TTF" )
START PRINTDOC


   START PRINTPAGE

         dibbarras :=  _StrToI2of5( BarCode.Text_1.value )
       
         cDescEfeito := ALLTRIM(barcode.Text_1.value)    
 
         @ 20,40 PRINT DibBarras Font "PF Interleaved 2 of 5" Size 45

         @ 40,40 PRINT cDescEfeito  Font "Arial" Size 13
 

   END PRINTPAGE

END PRINTDOC
RemoveFont("PF_I2OF5.TTF")

Return
